unit test;
{    ,  
       }
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Strbit32, ComCtrls, Buttons;

type
  TForm1 = class(TForm)
    DoAllop: TButton;
    Label3: TLabel;
    SE_Shg: TSpinEdit;
    LabelReadStr: TLabel;
    LabelReadNomer: TLabel;
    LabelPreob: TLabel;
    LabelBit: TLabel;
    Label10: TLabel;
    Label18: TLabel;
    SE_Kol: TSpinEdit;
    LabelSize: TLabel;
    Label8: TLabel;
    SEDlina: TSpinEdit;
    StatusBar1: TStatusBar;
    Edit1: TEdit;
    Label5: TLabel;
    SpeedButton1: TSpeedButton;
    EdOldName: TEdit;
    lbSizeInit: TLabel;
    seRazmer: TSpinEdit;
    Label9: TLabel;
    Label11: TLabel;
    seSmesh: TSpinEdit;
    oldFileName: TOpenDialog;
    BitBtn1: TBitBtn;
    LabelReadStrLong: TLabel;
    LabelReadNomerLong: TLabel;
    LongFileName: TEdit;
    SpeedButton2: TSpeedButton;
    LabelLongSize: TLabel;
    LabelBitLong: TLabel;
    LabelPreobLong: TLabel;
    procedure DoAllopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1Change(Sender: TObject);
    procedure SEDlinaChange(Sender: TObject);
    procedure seSmeshChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public
    StrF : TBitFile;
    LongStrF : TBitFileLong;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.DoAllopClick(Sender: TObject);
Var I, LenStr : integer;
begin
   StrF.CloseBitFile;
   StrF.OpenBitFile (EdOldName.Text, btCreate);
     {          }
   StrF.Init_Sim(Edit1.Text);
   LenStr := StrF.Size;
   for i := 0 to LenStr-1 do StrF.WriteBit(StrF[i]);
   for i := 1 to SE_Kol.Value do StrF.WriteStr;
   StrF.CloseBitFile;

   LongStrF.CloseBitFile;
   LongStrF.OpenBitFile (LongFileName.Text, btCreate, bt8  );
   LongStrF.Init_Sim(Edit1.Text);
   for i := 0 to LenStr-1 do LongStrF.WriteBit(LongStrF[i]);
   for i := 1 to SE_Kol.Value do LongStrF.WriteStr;
   LongStrF.CloseBitFile;

   {       }
   StrF.OpenBitFile (EdOldName.Text, btOpenRead  );
   I := StrF.SizeOfFile;
   LabelSize.Caption := IntToStr(i);

   LongStrF.OpenBitFile (LongFileName.Text, btOpenRead, bt8 );
   I := LongStrF.SizeOfFile;
   LabelLongSize.Caption := IntToStr(i);
   
   SE_Shg.MaxValue := i-1;         seSmesh.MaxValue := i-1;
   SEDlina.MaxValue := i-1;
   seSmeshChange(seSmesh);
   SEDlinaChange(SEDlina);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   StrF := TBitFile.Create;
   LongStrF := TBitFileLong.Create;
   Application.OnHint := ShowHint;
   DoAllopClick(EdOldName);   //      
end;

procedure TForm1.ShowHint(Sender: TObject);
begin
  StatusBar1.SimpleText := Application.Hint;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin   {        }
 if not oldFileName.Execute then Exit;
  EdOldName.Text := oldFileName.FileName;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   StrF.Free;
   LongStrF.Free;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin   {     }
  lbSizeInit.Caption := IntToStr(length(Edit1.Text));
end;

procedure TForm1.SEDlinaChange(Sender: TObject);
begin  {       
            }
 if SE_Shg.Value <= 0 then Exit;
 StrF.SeekStr(SE_Shg.Value);
 StrF.ReadStr(SEDlina.Value);
 LabelReadStr.Caption := StrF.Val_sim;
 StrF.SeekStr(SE_Shg.Value);
 LabelPreob.Caption := IntToStr( StrF.Nomer(0, seRazmer.Value) );
 LabelReadNomer.Caption := IntToStr( StrF.ReadNomer(seRazmer.Value));
 LongStrF.SeekStr(SE_Shg.Value);
 LongStrF.ReadStr(SEDlina.Value);
 LabelReadStrLong.Caption := LongStrF.Val_sim;
 LongStrF.SeekStr(SE_Shg.Value);
 LabelPreobLong.Caption := IntToStr( LongStrF.Nomer(0, seRazmer.Value) );
 LabelReadNomerLong.Caption := IntToStr( LongStrF.ReadNomer(seRazmer.Value));
end;

procedure TForm1.seSmeshChange(Sender: TObject);
begin  {     ,      }
 StrF.SeekStr ( seSmesh.Value );
 LabelBit.Caption := IntToStr( StrF.ReadBit);
 LabelReadStr.Caption := StrF.Val_sim;
 LongStrF.SeekStr ( seSmesh.Value );
 LabelBitLong.Caption := IntToStr( LongStrF.ReadBit);
 LabelReadStrLong.Caption := LongStrF.Val_sim;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin   {        }
 if not oldFileName.Execute then Exit;
  LongFileName.Text := oldFileName.FileName;
end;

end.
