//---------------------------------------------------------------------------

#pragma hdrstop

#include "BString.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------
void BitString::CopyFromFile(char*Path,unsigned long int X,unsigned long int Y)
//X,Y-     
//Path-     
//X<Y
//    S,  S . 
{
 BitString s;
 s.ReadStr(Path);
 this->CopyStr(s,X,Y);
}
//---------------------------------
void BitString::CopyStr(BitString x,unsigned long int y,unsigned long int z)
//     Y  Z
{
 this->ClearStr();
 for(unsigned long int i=y;i<=z;i++)
 {
   this->PuchBack(x.BString[i]);
 }
}
//---------------------------------
void BitString::ConvertToRev(void)
//     
//    
{
  unsigned char h=1;
  Bit y;
  unsigned char g=0;
 int f=0;
 BitString tt;tt.ClearStr();
 for(unsigned long int count=0;count<=this->BString.size();count++)
 {
   if(f==8)
    {
     f=0;
     do
 {
  
  for(int i=0;i<=7;i++)
  {
   y.Field=(g&h?1:0);
   tt.BString.push_back(y);
   g>>=1;
  }
 }while (count<=0);


     g=0;
    }
    switch(BString[count].Field)
    {
     case 0: break;
     case 1: switch(f)
             {
              case 0:g=g+128;break;
              case 1:g=g+64; break;
              case 2:g=g+32; break;
              case 3:g=g+16; break;
              case 4:g=g+8;  break;
              case 5:g=g+4;  break;
              case 6:g=g+2;  break;
              case 7:g++;    break;
             }
    }


  f++;
 }
 this->BString=tt.BString;
 }

//---------------------------------
Bit BitString::SumReg(BitString x)
{
 Bit ui;
 unsigned int z=0;
 for(unsigned long int i=0;i<=x.SizeStr()-1;i++)
 {
  if(this->BString[i].Field==1 &&   x.BString[i].Field==1)
  {
  if(z==0)z++;
  else z--;
  }
 }
 if(z==true)ui.Field=1;   
 else ui.Field=0;
 return ui;
}
//---------------------------------
void BitString::IntToBit(unsigned int x)
//     ,..   
//  32-         
{
 this->ClearStr();
 unsigned int g;
 unsigned int h=1;

 Bit y;


  g=x;
  for(int i=0;i<=32;i++)
  {
   y.Field=(g&h?1:0);
   BString.push_back(y);
   g>>=1;
  }

}
//---------------------------------
void BitString::ReadStrRev(char*Path)
//         
//Path -      
{
 this->ClearStr();
 unsigned char g=0;
 unsigned char h=1<<7;

 Bit y;
 ifstream infile(Path,ios::in);
 do
 {
  infile.read((char*)&g,sizeof(g));
  for(int i=0;i<=7;i++)
  {
   y.Field=(g&h?1:0);
   BString.push_back(y);
   g<<=1;
  }
 }
 while(infile.eof()==false);
 for(char i=0;i<8;i++)BString.pop_back();
 infile.close();
}
//---------------------------------
void BitString::Init_0(unsigned long int x)
//   
//   
{
 this->ClearStr();
 for(unsigned long int i=0;i<=x;i++)BString.push_back(bt0);
}
//---------------------------------
void BitString::Init_1(unsigned long int x)
//   
//   
{
 this->ClearStr();
 for(unsigned long int i=0;i<=x;i++)BString.push_back(bt1);
}

//---------------------------------
void BitString::InvStr(void)
//     
{
 for(unsigned long int i=0;i<=BString.size();i++)
 {
   if(this->BString[i].Field==1)this->BString[i].Field=0;
   else this->BString[i].Field=1;
 }
}
//---------------------------------
void BitString::InvBit(unsigned long int x)
//     
{
 if(this->BString[x].Field==1)this->BString[x].Field=0;
 else this->BString[x].Field=1;
}
//---------------------------------
int BitString::FindStr(BitString x)
//   ,     
//  .
//     0
//       .
{
 unsigned long int y=x.SizeStr()-1;
 for(unsigned long int i=0;i<=this->SizeStr();i++)
 {
  for(unsigned long int u=0;u<=y;u++)
  {
    if(this->BString[i+u].Field!=x.BString[u].Field)break;
    if(u==y)return (i);
  }
  
 } return 0;
}
//---------------------------------
void BitString::ReadStr(char*Path)
//      ,
//  
//Path      
{
 this->ClearStr();
 unsigned char g=0;
 unsigned char h=1;

 Bit y;
 ifstream infile(Path,ios::in);
 while(infile.eof()==false)
 {
  infile.read((char*)&g,sizeof(g));
  for(int i=0;i<=7;i++)
  {
   y.Field=(g&h?1:0);
   BString.push_back(y);
   g>>=1;
  }
  if(infile.eof()==true)break;
 };
 for(char i=0;i<8;i++)BString.pop_back();
 infile.close();
}
//---------------------------------

//---------------------------------
void BitString::WriteStrRev(char *Path)
//        
// .Path-      
{
 unsigned char g=0;
 int f=0;
 ofstream files(Path,ios::out);
 for(unsigned long int count=0;count<=BString.size();count++)
 {
   if(f==8)
    {
     f=0;

     files<<g;
     g=0;
    }
   if(f!=8 && count==BString.size()+1)
    {
     files<<g;
    }  
    switch(BString[count].Field)
    {
     case 0: break;
     case 1: switch(f)
             {
              case 0:g=g+128;break;
              case 1:g=g+64; break;
              case 2:g=g+32; break;
              case 3:g=g+16; break;
              case 4:g=g+8;  break;
              case 5:g=g+4;  break;
              case 6:g=g+2;  break;
              case 7:g++;    break;
             }
    }


  f++;
 }
 files.close();
}


//-------------------------------
BitString::~BitString()
// ( ).   
//   .  .
{
this->ClearStr();
}


//------------------------------
void BitString::Mod2(BitString x)
//       
//  X  mod(2),       
//    ,   .
{
 unsigned long int y=0;
 if(this->SizeStr()>=x.SizeStr())y=x.SizeStr();
 if(this->SizeStr()<=x.SizeStr())y=this->SizeStr();
 do
 {
   this->BString.pop_back();
 }while(this->SizeStr()>y);
 for(unsigned long int i=0;i<=y;i++)
 {
  if(this->BString[i].Field==1&&x.BString[i].Field==1){this->BString[i].Field=0;continue;}
  if(this->BString[i].Field==0&&x.BString[i].Field==1){this->BString[i].Field=1;continue;}
  if(this->BString[i].Field==1&&x.BString[i].Field==0){this->BString[i].Field=1;continue;}
  if(this->BString[i].Field==0&&x.BString[i].Field==0){this->BString[i].Field=0;continue;}
 }

}

  //-----------------------------
int BitString::Count_0(void)
//      
{
 int g=0;
 for(unsigned int count=0;count<=BString.size();count++)
 {
  if(BString[count].Field==0)g++;
 }
 return g;
}
//-----------------------------
int BitString::Count_1(void)
//      
{
 int g=0;
 for(unsigned long int count=0;count<=BString.size();count++)
 {
  if(BString[count].Field==1)g++;
 }
 return g;
}
//-----------------------------
void BitString::SwapBit(unsigned long int x,unsigned long int y)
//    c  X  Y
{
 p=BString.begin();
 Convert_Int_To_Bit(y-2);
 e=p;
 Convert_Int_To_Bit(x-2);
 iter_swap(p,e);
}
//-----------------------------
void BitString::EraseStr(unsigned long int x,unsigned long int y)
//   X  Y.    ,    EraseBit();
{
 p=BString.begin();
 Convert_Int_To_Bit(y);
 e=p;
 Convert_Int_To_Bit(x);
 BString.erase(p-1,e);
}
//-----------------------------
void BitString::EraseBit(unsigned long int index)
//    R,     
//    .  
//.
{
 p=BString.begin();
 Convert_Int_To_Bit(index);
 BString.erase(p-1);
}
//------------------------------------
void BitString::WriteStr(char *Path)
//     ,     
//  Path -     
{
 unsigned char g=0;
 int f=0;
 ofstream files(Path,ios::out);
 for(unsigned long int count=0;count<=BString.size();count++)
 {
   if(f==8)
    {
     f=0;

     files<<g;
     g=0;
    }
   if(f!=8 && count==BString.size())
    {
     files<<g;
    } 
    switch(BString[count].Field)
    {
     case 0: break;
     case 1: switch(f)
             {
              case 0:g++;    break;
              case 1:g=g+2;  break;
              case 2:g=g+4;  break;
              case 3:g=g+8;  break;
              case 4:g=g+16; break;
              case 5:g=g+32; break;
              case 6:g=g+64; break;
              case 7:g=g+128;break;
             }
    }


  f++;
 }
 files.close();
}
//------------------------------------
char* BitString::BitToChar(void)
//    .  
//   (  ),
//       AnsiString,String.
{
 char *Ret;
 Ret=new char[this->BString.size()];
 for(unsigned long int count=0;count<=this->BString.size();count++)
 {
  if(this->BString[count].Field==1)Ret[count]='1';
  if(this->BString[count].Field==0)Ret[count]='0';
 }
 return Ret;
}

//------------------------------------
void BitString::StrToBit( char *s)
//    .   
//     (
//     0  1  
//     ).
//   - 
{
  BString.resize(0);
  for(unsigned long int count=0;count<=strlen(s)-1;count++)
  {
   assert(s[count]=='1'  || s[count]=='0');
   if(s[count]=='1')BString.push_back(bt1);
   if(s[count]=='0')BString.push_back(bt0);
  }
}

//------------------------------------
void BitString::JoinStr(BitString x)
{
 for(unsigned long i=0;i<=x.SizeStr();i++)
 {
   this->BString.push_back(x.BString[i]);
 }
}
//------------------------------------
void BitString::RightStr(int e)
//           ;
{
 reverse(BString.begin(),BString.end());
 rotate(BString.begin(),BString.begin()+e,BString.end());
 reverse(BString.begin(),BString.end());
}
//------------------------------------
void BitString::LeftStr(int e)
//          ;
{
 rotate(BString.begin(),BString.begin()+e,BString.end());
}

//------------------------------------
void BitString::ReverseStr()
//          ;
{
  reverse(BString.begin(),BString.end());
}

//------------------------------------
void BitString::RandomStr(int index)
//    (R- 
//).     .
{
  int f;
  if(index<=5)f=index;
  else f=5;
  for(int i=1;i<=f;i++) random_shuffle(BString.begin(), BString.end());

}

//------------------------------------
void BitString::ReSizeStr(unsigned long int index,Bit Z)
//   ,       
//      Z.
{
 BString.resize(index,Z);
}
//------------------------------------
void BitString::PopBack()
//    
{
 BString.pop_back();
}
//------------------------------------
void BitString::Convert_Int_To_Bit(unsigned long int index)
// .     
//  index
{
 this->p=BString.begin();
 for(unsigned long int count=0;count<=index;count++)
 {
   p++;
 }
}

//------------------------------------
void BitString::PuchBack(Bit Z)
//  Z   
{
 this->BString.push_back(Z);
}
//------------------------------------
unsigned long int BitString::MaxSize(void)
{
 return BString.max_size();
}
//------------------------------------
void BitString::InsertBit(unsigned long int index,unsigned long int Z,Bit h)   // ??????????????
// Z   h   index;
// h   0  1   
{
  assert(h.Field==1 || h.Field==0);
  Convert_Int_To_Bit(index);
  BString.insert(p,Z,h);
}
//------------------------------------
void BitString::ClearStr(void)
//      
// .     .
{
 BString.clear();
}
//------------------------------------
unsigned long int BitString::SizeStr(void)
//   
{
 return BString.size();
 }
//------------------------------------
BitString::BitString()
{
   bt1.Field=1;
   bt0.Field=0;
   BString.push_back(bt0);
   BString.push_back(bt0);
   BString.push_back(bt0);
   p=BString.begin();
   e=BString.end();
}
//-----------------------------------
unsigned long int BitString::operator[](unsigned long int y)
//  []   BitString
//       
//( )
{
 return BString[y].Field;
}
//------------------------------------
void BitString::operator=(BitString x)
//  =   BitString
//       
// , ..   
//  X   .   
//    X
{
 this->ClearStr();
 for(unsigned long int count=0;count<=x.SizeStr();count++)
 {
  if(x[count]==1) this->PuchBack(bt1);
  else this->PuchBack(bt0);
 }
}
