

//          *************************************************************
//          * :                    *
//          *                                                           *
//          *       - *
//          *      unsigned (long) int    *
//          *                                                           *
//          *       *
//          *   BitString  AnsiString               *
//          *    32-       *
//          *   dstring.h                            *
//          *************************************************************

#ifndef BITSTRING_H
#define BITSTRING_H



#include<vector.h>
#include<fstream.h>
#include<iostream.h>
#include<bitset.h>
#include<assert.h>
#include <algorithm>
#include<algorith>
#include<string.h>


using namespace std;
struct Bit
//   Bit
{
 unsigned long int  Field:1;
 //     Bit
 bool operator==(Bit y)
 {
  return this->Field==y.Field;
 }
 bool operator<(Bit y)
 {
  return this->Field< y.Field;
 }
 bool operator>(Bit y)
 {
  return this->Field> y.Field;
 }
 Bit operator+(Bit y)
 //  + mod(2)
 {
  Bit g;
  if(this->Field==1 && y.Field==1)g.Field=0;
  if(this->Field==0 && y.Field==0)g.Field=0;
  if(this->Field==1 && y.Field==0)g.Field=1;
  if(this->Field==0 && y.Field==1)g.Field=1;
  return g;
  }
};






class BitString
{
  private:
    vector<Bit>::iterator p;
    vector<Bit>::iterator e;
    vector<Bit>::iterator dl;
    void Convert_Int_To_Bit(unsigned long int);
    vector<Bit> BString;

  public:
    BitString();
    ~BitString();
    Bit bt1;
    Bit bt0;

    void Mod2(BitString);
    unsigned long int operator[](unsigned long int);
    void operator=(BitString);


    unsigned long int SizeStr(void);
    // -
    void ClearStr(void);
    //   -
    void InsertBit(unsigned long int ,unsigned long int,Bit);
    //    index
    unsigned long int MaxSize(void);
    //  ,    
    // 
    void PuchBack(Bit);
    // .(  )
    void PopBack(void);
    //  
    void ReSizeStr(unsigned long int,Bit);
    //  
    void RandomStr(int);
    //  
    //  index(<=5)
    void ReverseStr(void);
    //     
    void LeftStr(int e);
    //    
    //
    void RightStr(int e);
    // /    
    //
    void JoinStr(BitString x);
    // 
    //   X
    void StrToBit(char *);
    //    
    char* BitToChar(void);
    //    
    void WriteStr(char*);
    //    
    void EraseBit(unsigned long int);
    // 
    void EraseStr(unsigned long int,unsigned long int);
    // 
    void SwapBit( unsigned long int,unsigned long int );
    //    
    int Count_1(void);
    // - "1" 
    int Count_0(void);
    // - "0" 
    void WriteStrRev(char*);
    //    ,     WriteStr() -
    //      
    void ReadStrRev(char*);
    //  ()
    void ReadStr(char*)  ;
    //  
    int FindStr(BitString);
    //   , 
    //     
    void InvBit(unsigned long int );
    // 
    void InvStr(void);
    //  
    void Init_1(unsigned long int);
    //  "1"
    void Init_0(unsigned long int);
    //  "0"
    void IntToBit(unsigned int);
    //  ( )  
    Bit SumReg(BitString);
    //    
    void ConvertToRev(void);
    //     
    void CopyStr(BitString,unsigned long int,unsigned long int);
    //    
    void  CopyFromFile(char*Path,unsigned long int,unsigned long int);
    //      Y  Z *Path   
    //  
    
};
#endif

